/* Unicorn Engine */
/* By Nguyen Anh Quynh <aquynh@gmail.com>, 2015-2017 */
/* This file is released under LGPL2.
   See COPYING.LGPL2 in root directory for more details
*/

#ifndef QNICORN_PPC_H
#define QNICORN_PPC_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _MSC_VER
#pragma warning(disable : 4201)
#endif

//> PPC CPU
typedef enum qc_cpu_ppc {
    QC_CPU_PPC_401 = 0,
    QC_CPU_PPC_401A1,
    QC_CPU_PPC_401B2,
    QC_CPU_PPC_401C2,
    QC_CPU_PPC_401D2,
    QC_CPU_PPC_401E2,
    QC_CPU_PPC_401F2,
    QC_CPU_PPC_401G2,
    QC_CPU_PPC_IOP480,
    QC_CPU_PPC_COBRA,
    QC_CPU_PPC_403GA,
    QC_CPU_PPC_403GB,
    QC_CPU_PPC_403GC,
    QC_CPU_PPC_403GCX,
    QC_CPU_PPC_405D2,
    QC_CPU_PPC_405D4,
    QC_CPU_PPC_405CRA,
    QC_CPU_PPC_405CRB,
    QC_CPU_PPC_405CRC,
    QC_CPU_PPC_405EP,
    QC_CPU_PPC_405EZ,
    QC_CPU_PPC_405GPA,
    QC_CPU_PPC_405GPB,
    QC_CPU_PPC_405GPC,
    QC_CPU_PPC_405GPD,
    QC_CPU_PPC_405GPR,
    QC_CPU_PPC_405LP,
    QC_CPU_PPC_NPE405H,
    QC_CPU_PPC_NPE405H2,
    QC_CPU_PPC_NPE405L,
    QC_CPU_PPC_NPE4GS3,
    QC_CPU_PPC_STB03,
    QC_CPU_PPC_STB04,
    QC_CPU_PPC_STB25,
    QC_CPU_PPC_X2VP4,
    QC_CPU_PPC_X2VP20,
    QC_CPU_PPC_440_XILINX,
    QC_CPU_PPC_440_XILINX_W_DFPU,
    QC_CPU_PPC_440EPA,
    QC_CPU_PPC_440EPB,
    QC_CPU_PPC_440EPX,
    QC_CPU_PPC_460EXB,
    QC_CPU_PPC_G2,
    QC_CPU_PPC_G2H4,
    QC_CPU_PPC_G2GP,
    QC_CPU_PPC_G2LS,
    QC_CPU_PPC_G2HIP3,
    QC_CPU_PPC_G2HIP4,
    QC_CPU_PPC_MPC603,
    QC_CPU_PPC_G2LE,
    QC_CPU_PPC_G2LEGP,
    QC_CPU_PPC_G2LELS,
    QC_CPU_PPC_G2LEGP1,
    QC_CPU_PPC_G2LEGP3,
    QC_CPU_PPC_MPC5200_V10,
    QC_CPU_PPC_MPC5200_V11,
    QC_CPU_PPC_MPC5200_V12,
    QC_CPU_PPC_MPC5200B_V20,
    QC_CPU_PPC_MPC5200B_V21,
    QC_CPU_PPC_E200Z5,
    QC_CPU_PPC_E200Z6,
    QC_CPU_PPC_E300C1,
    QC_CPU_PPC_E300C2,
    QC_CPU_PPC_E300C3,
    QC_CPU_PPC_E300C4,
    QC_CPU_PPC_MPC8343,
    QC_CPU_PPC_MPC8343A,
    QC_CPU_PPC_MPC8343E,
    QC_CPU_PPC_MPC8343EA,
    QC_CPU_PPC_MPC8347T,
    QC_CPU_PPC_MPC8347P,
    QC_CPU_PPC_MPC8347AT,
    QC_CPU_PPC_MPC8347AP,
    QC_CPU_PPC_MPC8347ET,
    QC_CPU_PPC_MPC8347EP,
    QC_CPU_PPC_MPC8347EAT,
    QC_CPU_PPC_MPC8347EAP,
    QC_CPU_PPC_MPC8349,
    QC_CPU_PPC_MPC8349A,
    QC_CPU_PPC_MPC8349E,
    QC_CPU_PPC_MPC8349EA,
    QC_CPU_PPC_MPC8377,
    QC_CPU_PPC_MPC8377E,
    QC_CPU_PPC_MPC8378,
    QC_CPU_PPC_MPC8378E,
    QC_CPU_PPC_MPC8379,
    QC_CPU_PPC_MPC8379E,
    QC_CPU_PPC_E500_V10,
    QC_CPU_PPC_E500_V20,
    QC_CPU_PPC_E500V2_V10,
    QC_CPU_PPC_E500V2_V20,
    QC_CPU_PPC_E500V2_V21,
    QC_CPU_PPC_E500V2_V22,
    QC_CPU_PPC_E500V2_V30,
    QC_CPU_PPC_E500MC,
    QC_CPU_PPC_MPC8533_V10,
    QC_CPU_PPC_MPC8533_V11,
    QC_CPU_PPC_MPC8533E_V10,
    QC_CPU_PPC_MPC8533E_V11,
    QC_CPU_PPC_MPC8540_V10,
    QC_CPU_PPC_MPC8540_V20,
    QC_CPU_PPC_MPC8540_V21,
    QC_CPU_PPC_MPC8541_V10,
    QC_CPU_PPC_MPC8541_V11,
    QC_CPU_PPC_MPC8541E_V10,
    QC_CPU_PPC_MPC8541E_V11,
    QC_CPU_PPC_MPC8543_V10,
    QC_CPU_PPC_MPC8543_V11,
    QC_CPU_PPC_MPC8543_V20,
    QC_CPU_PPC_MPC8543_V21,
    QC_CPU_PPC_MPC8543E_V10,
    QC_CPU_PPC_MPC8543E_V11,
    QC_CPU_PPC_MPC8543E_V20,
    QC_CPU_PPC_MPC8543E_V21,
    QC_CPU_PPC_MPC8544_V10,
    QC_CPU_PPC_MPC8544_V11,
    QC_CPU_PPC_MPC8544E_V10,
    QC_CPU_PPC_MPC8544E_V11,
    QC_CPU_PPC_MPC8545_V20,
    QC_CPU_PPC_MPC8545_V21,
    QC_CPU_PPC_MPC8545E_V20,
    QC_CPU_PPC_MPC8545E_V21,
    QC_CPU_PPC_MPC8547E_V20,
    QC_CPU_PPC_MPC8547E_V21,
    QC_CPU_PPC_MPC8548_V10,
    QC_CPU_PPC_MPC8548_V11,
    QC_CPU_PPC_MPC8548_V20,
    QC_CPU_PPC_MPC8548_V21,
    QC_CPU_PPC_MPC8548E_V10,
    QC_CPU_PPC_MPC8548E_V11,
    QC_CPU_PPC_MPC8548E_V20,
    QC_CPU_PPC_MPC8548E_V21,
    QC_CPU_PPC_MPC8555_V10,
    QC_CPU_PPC_MPC8555_V11,
    QC_CPU_PPC_MPC8555E_V10,
    QC_CPU_PPC_MPC8555E_V11,
    QC_CPU_PPC_MPC8560_V10,
    QC_CPU_PPC_MPC8560_V20,
    QC_CPU_PPC_MPC8560_V21,
    QC_CPU_PPC_MPC8567,
    QC_CPU_PPC_MPC8567E,
    QC_CPU_PPC_MPC8568,
    QC_CPU_PPC_MPC8568E,
    QC_CPU_PPC_MPC8572,
    QC_CPU_PPC_MPC8572E,
    QC_CPU_PPC_E600,
    QC_CPU_PPC_MPC8610,
    QC_CPU_PPC_MPC8641,
    QC_CPU_PPC_MPC8641D,
    QC_CPU_PPC_601_V0,
    QC_CPU_PPC_601_V1,
    QC_CPU_PPC_601_V2,
    QC_CPU_PPC_602,
    QC_CPU_PPC_603,
    QC_CPU_PPC_603E_V1_1,
    QC_CPU_PPC_603E_V1_2,
    QC_CPU_PPC_603E_V1_3,
    QC_CPU_PPC_603E_V1_4,
    QC_CPU_PPC_603E_V2_2,
    QC_CPU_PPC_603E_V3,
    QC_CPU_PPC_603E_V4,
    QC_CPU_PPC_603E_V4_1,
    QC_CPU_PPC_603E7,
    QC_CPU_PPC_603E7T,
    QC_CPU_PPC_603E7V,
    QC_CPU_PPC_603E7V1,
    QC_CPU_PPC_603E7V2,
    QC_CPU_PPC_603P,
    QC_CPU_PPC_604,
    QC_CPU_PPC_604E_V1_0,
    QC_CPU_PPC_604E_V2_2,
    QC_CPU_PPC_604E_V2_4,
    QC_CPU_PPC_604R,
    QC_CPU_PPC_740_V1_0,
    QC_CPU_PPC_750_V1_0,
    QC_CPU_PPC_740_V2_0,
    QC_CPU_PPC_750_V2_0,
    QC_CPU_PPC_740_V2_1,
    QC_CPU_PPC_750_V2_1,
    QC_CPU_PPC_740_V2_2,
    QC_CPU_PPC_750_V2_2,
    QC_CPU_PPC_740_V3_0,
    QC_CPU_PPC_750_V3_0,
    QC_CPU_PPC_740_V3_1,
    QC_CPU_PPC_750_V3_1,
    QC_CPU_PPC_740E,
    QC_CPU_PPC_750E,
    QC_CPU_PPC_740P,
    QC_CPU_PPC_750P,
    QC_CPU_PPC_750CL_V1_0,
    QC_CPU_PPC_750CL_V2_0,
    QC_CPU_PPC_750CX_V1_0,
    QC_CPU_PPC_750CX_V2_0,
    QC_CPU_PPC_750CX_V2_1,
    QC_CPU_PPC_750CX_V2_2,
    QC_CPU_PPC_750CXE_V2_1,
    QC_CPU_PPC_750CXE_V2_2,
    QC_CPU_PPC_750CXE_V2_3,
    QC_CPU_PPC_750CXE_V2_4,
    QC_CPU_PPC_750CXE_V2_4B,
    QC_CPU_PPC_750CXE_V3_0,
    QC_CPU_PPC_750CXE_V3_1,
    QC_CPU_PPC_750CXE_V3_1B,
    QC_CPU_PPC_750CXR,
    QC_CPU_PPC_750FL,
    QC_CPU_PPC_750FX_V1_0,
    QC_CPU_PPC_750FX_V2_0,
    QC_CPU_PPC_750FX_V2_1,
    QC_CPU_PPC_750FX_V2_2,
    QC_CPU_PPC_750FX_V2_3,
    QC_CPU_PPC_750GL,
    QC_CPU_PPC_750GX_V1_0,
    QC_CPU_PPC_750GX_V1_1,
    QC_CPU_PPC_750GX_V1_2,
    QC_CPU_PPC_750L_V2_0,
    QC_CPU_PPC_750L_V2_1,
    QC_CPU_PPC_750L_V2_2,
    QC_CPU_PPC_750L_V3_0,
    QC_CPU_PPC_750L_V3_2,
    QC_CPU_PPC_745_V1_0,
    QC_CPU_PPC_755_V1_0,
    QC_CPU_PPC_745_V1_1,
    QC_CPU_PPC_755_V1_1,
    QC_CPU_PPC_745_V2_0,
    QC_CPU_PPC_755_V2_0,
    QC_CPU_PPC_745_V2_1,
    QC_CPU_PPC_755_V2_1,
    QC_CPU_PPC_745_V2_2,
    QC_CPU_PPC_755_V2_2,
    QC_CPU_PPC_745_V2_3,
    QC_CPU_PPC_755_V2_3,
    QC_CPU_PPC_745_V2_4,
    QC_CPU_PPC_755_V2_4,
    QC_CPU_PPC_745_V2_5,
    QC_CPU_PPC_755_V2_5,
    QC_CPU_PPC_745_V2_6,
    QC_CPU_PPC_755_V2_6,
    QC_CPU_PPC_745_V2_7,
    QC_CPU_PPC_755_V2_7,
    QC_CPU_PPC_745_V2_8,
    QC_CPU_PPC_755_V2_8,
    QC_CPU_PPC_7400_V1_0,
    QC_CPU_PPC_7400_V1_1,
    QC_CPU_PPC_7400_V2_0,
    QC_CPU_PPC_7400_V2_1,
    QC_CPU_PPC_7400_V2_2,
    QC_CPU_PPC_7400_V2_6,
    QC_CPU_PPC_7400_V2_7,
    QC_CPU_PPC_7400_V2_8,
    QC_CPU_PPC_7400_V2_9,
    QC_CPU_PPC_7410_V1_0,
    QC_CPU_PPC_7410_V1_1,
    QC_CPU_PPC_7410_V1_2,
    QC_CPU_PPC_7410_V1_3,
    QC_CPU_PPC_7410_V1_4,
    QC_CPU_PPC_7448_V1_0,
    QC_CPU_PPC_7448_V1_1,
    QC_CPU_PPC_7448_V2_0,
    QC_CPU_PPC_7448_V2_1,
    QC_CPU_PPC_7450_V1_0,
    QC_CPU_PPC_7450_V1_1,
    QC_CPU_PPC_7450_V1_2,
    QC_CPU_PPC_7450_V2_0,
    QC_CPU_PPC_7450_V2_1,
    QC_CPU_PPC_7441_V2_1,
    QC_CPU_PPC_7441_V2_3,
    QC_CPU_PPC_7451_V2_3,
    QC_CPU_PPC_7441_V2_10,
    QC_CPU_PPC_7451_V2_10,
    QC_CPU_PPC_7445_V1_0,
    QC_CPU_PPC_7455_V1_0,
    QC_CPU_PPC_7445_V2_1,
    QC_CPU_PPC_7455_V2_1,
    QC_CPU_PPC_7445_V3_2,
    QC_CPU_PPC_7455_V3_2,
    QC_CPU_PPC_7445_V3_3,
    QC_CPU_PPC_7455_V3_3,
    QC_CPU_PPC_7445_V3_4,
    QC_CPU_PPC_7455_V3_4,
    QC_CPU_PPC_7447_V1_0,
    QC_CPU_PPC_7457_V1_0,
    QC_CPU_PPC_7447_V1_1,
    QC_CPU_PPC_7457_V1_1,
    QC_CPU_PPC_7457_V1_2,
    QC_CPU_PPC_7447A_V1_0,
    QC_CPU_PPC_7457A_V1_0,
    QC_CPU_PPC_7447A_V1_1,
    QC_CPU_PPC_7457A_V1_1,
    QC_CPU_PPC_7447A_V1_2,
    QC_CPU_PPC_7457A_V1_2,
} qc_cpu_ppc;

//> PPC64 CPU
typedef enum qc_cpu_ppc64 {
    QC_CPU_PPC_E5500 = 0,
    QC_CPU_PPC_E6500,
    QC_CPU_PPC_970_V2_2,
    QC_CPU_PPC_970FX_V1_0,
    QC_CPU_PPC_970FX_V2_0,
    QC_CPU_PPC_970FX_V2_1,
    QC_CPU_PPC_970FX_V3_0,
    QC_CPU_PPC_970FX_V3_1,
    QC_CPU_PPC_970MP_V1_0,
    QC_CPU_PPC_970MP_V1_1,
    QC_CPU_PPC_POWER5_V2_1,
    QC_CPU_PPC_POWER7_V2_3,
    QC_CPU_PPC_POWER7_V2_1,
    QC_CPU_PPC_POWER8E_V2_1,
    QC_CPU_PPC_POWER8_V2_0,
    QC_CPU_PPC_POWER8NVL_V1_0,
    QC_CPU_PPC_POWER9_V1_0,
    QC_CPU_PPC_POWER9_V2_0,
    QC_CPU_PPC_POWER10_V1_0,
} qc_cpu_ppc64;

//> PPC registers
typedef enum qc_ppc_reg {
    QC_PPC_REG_INVALID = 0,
    //> General purpose registers
    QC_PPC_REG_PC,

    QC_PPC_REG_0,
    QC_PPC_REG_1,
    QC_PPC_REG_2,
    QC_PPC_REG_3,
    QC_PPC_REG_4,
    QC_PPC_REG_5,
    QC_PPC_REG_6,
    QC_PPC_REG_7,
    QC_PPC_REG_8,
    QC_PPC_REG_9,
    QC_PPC_REG_10,
    QC_PPC_REG_11,
    QC_PPC_REG_12,
    QC_PPC_REG_13,
    QC_PPC_REG_14,
    QC_PPC_REG_15,
    QC_PPC_REG_16,
    QC_PPC_REG_17,
    QC_PPC_REG_18,
    QC_PPC_REG_19,
    QC_PPC_REG_20,
    QC_PPC_REG_21,
    QC_PPC_REG_22,
    QC_PPC_REG_23,
    QC_PPC_REG_24,
    QC_PPC_REG_25,
    QC_PPC_REG_26,
    QC_PPC_REG_27,
    QC_PPC_REG_28,
    QC_PPC_REG_29,
    QC_PPC_REG_30,
    QC_PPC_REG_31,
} qc_ppc_reg;

#ifdef __cplusplus
}
#endif

#endif
